//----------------------------------------------------------------------------------
#property copyright "www.forex-tsd.com, modified by Airquest - airquest@hotmail.com"
#property link      "www.forex-tsd.com, modified by Airquest - airquest@hotmail.com"
//----------------------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers   2
#property indicator_color1    LimeGreen
#property indicator_color2    Orange
#property indicator_style2    STYLE_DOT
#property indicator_width1    2
#property indicator_minimum  -5
#property indicator_maximum 105
#property indicator_level1   80
#property indicator_level2   20
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int    TimeFrame              = 0;
extern int    StochasticPeriod       = 50;
extern int    StochasticSignalPeriod = 10;
extern int    MaPeriod               = 6;
extern int    MaMethod               = 2;
extern int    MaPeriod2              = 2;
extern int    MaMethod2              = 3;
extern bool   Interpolate            = True;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double ExtMapBuffer1[];

//---------------------------MTF-------------------------------------
string TF,IndicatorName;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,ExtMapBuffer1);
   IndicatorShortName("Stochastic of HAMA ("+StochasticPeriod+","+StochasticSignalPeriod+","+MaPeriod+","+MaMethod+","+MaPeriod2+","+MaMethod2+")");
   

//---------------------------MTF-------------------------------------
   switch(TimeFrame)
   {
      case 1:     string TimeFrameStr ="M1";  break;
      case 5:     TimeFrameStr ="M5";         break;
      case 15:    TimeFrameStr ="M15";        break;
      case 30:    TimeFrameStr ="M30";        break;
      case 60:    TimeFrameStr ="H1";         break;
      case 240:   TimeFrameStr ="H4";         break;
      case 1440:  TimeFrameStr ="D1";         break;
      case 10080: TimeFrameStr ="W1";         break;
      case 43200: TimeFrameStr ="MN1";        break;
      default:    TimeFrameStr ="Current";
   }
   IndicatorName = WindowExpertName();
   if(TimeFrame <= Period()) TimeFrame = Period();
   TF = tf(TimeFrame);
   if(TF  == "Current") TimeFrame = Period();
//------------------------------------------------------------------
   
   
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   double maOpen, maClose, maLow, maHigh;
   double haClose;
   
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
   


//---------------------------MTF-------------------------------------
   if(TimeFrame != Period())
	{
   limit = MathMax(limit,TimeFrame/Period());
      for(int shift=0; shift<limit; shift++)
      {	
      int y = iBarShift(NULL,TimeFrame,Time[shift]);
      buffer1[shift]       = iCustom(NULL,TimeFrame,IndicatorName,0,StochasticPeriod,StochasticSignalPeriod,MaPeriod,MaMethod,MaPeriod2,MaMethod2,0,y);
      buffer2[shift]       = iCustom(NULL,TimeFrame,IndicatorName,0,StochasticPeriod,StochasticSignalPeriod,MaPeriod,MaMethod,MaPeriod2,MaMethod2,1,y);
      buffer3[shift]       = iCustom(NULL,TimeFrame,IndicatorName,0,StochasticPeriod,StochasticSignalPeriod,MaPeriod,MaMethod,MaPeriod2,MaMethod2,2,y);
      ExtMapBuffer1[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,StochasticPeriod,StochasticSignalPeriod,MaPeriod,MaMethod,MaPeriod2,MaMethod2,3,y);
      
//+-------------------------------------Interpolation-------------------------------------+
         
         if (Interpolate<1 || y==iBarShift(NULL,TimeFrame,Time[shift-1])) continue;
         
               datetime time = iTime(NULL,TimeFrame,y);
               for(int n = 1; shift+n < Bars && Time[shift+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  buffer1[shift+k]        = buffer1[shift] + (buffer1[shift+n]-buffer1[shift])*k/n;
                  buffer2[shift+k]        = buffer2[shift] + (buffer2[shift+n]-buffer2[shift])*k/n;
                  buffer3[shift+k]        = buffer3[shift] + (buffer3[shift+n]-buffer3[shift])*k/n;
                  ExtMapBuffer1[shift+k]  = ExtMapBuffer1[shift] + (ExtMapBuffer1[shift+n]-ExtMapBuffer1[shift])*k/n;
               }
         
//+---------------------------------------------------------------------------------------+
      
      
      
      }
   return(0);
   }
//------------------------------------------------------------------  



   int pos=Bars-counted_bars-1;
   while(pos>=0)
     {
      maOpen  =iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_OPEN,pos);
      maClose =iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_CLOSE,pos);
      maLow   =iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_LOW,pos);
      maHigh  =iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_HIGH,pos);

      haClose=(maOpen+maHigh+maLow+maClose)/4;
      ExtMapBuffer1[pos]=haClose;

 	   pos--;
     }
   
   //
   //

   double alpha = 2.0 / (1.0 + StochasticSignalPeriod);
   for(int i=limit; i>=0; i--)
   {
      buffer3[i] = iMAOnArray(ExtMapBuffer1,Bars,MaPeriod2,0,MaMethod2,i);
      
      double hi = buffer3[ArrayMaximum(buffer3,StochasticPeriod,i)];
      double lo = buffer3[ArrayMinimum(buffer3,StochasticPeriod,i)];
      if (hi != lo)
            buffer1[i] = 100*(buffer3[i]-lo)/(hi-lo);
      else  buffer1[i] = 0.00;
      if (StochasticSignalPeriod>1)
            buffer2[i] = buffer2[i+1] + alpha*(buffer1[i]-buffer2[i+1]);
   }         
   return(0);
}

//
//
//
//------------------------------------------------------------------


//---------------------------MTF-------------------------------------

string tf(int timeframe)
{
   switch(timeframe)
   {
   case 0:     return("M1");
   case 5:     return("M5");
   case 15:    return("M15");
   case 30:    return("M30");
   case 60:    return("H1");
   case 240:   return("H4");
   case 1440:  return("D1");
   case 10080: return("W1");
   case 43200: return("MN1");
   default:    return("Current");
   }
}

//------------------------------------------------------------------